using System.Collections.Generic;
using System.Linq;

#if !HURTWORLD
using Assets.Scripts.Core;
#endif

// Aktualizacja - OxidePolska

namespace Oxide.Plugins {

    [Info ("Insta Smelt", "Jojolepro & Mr. Blue", "2.0.2")]
    [Description ("Smelts stacks of items at once.")]

    class InstaSmelt : HurtworldPlugin {
        protected void OnServerInitialized () {
#if HURTWORLD
            EntityFluidEffectKey k = RuntimeHurtDB.Instance.GetAll<EntityFluidEffectKey> ().FirstOrDefault (e => e.NameKey == "EntityStats/Effects/Storage Temperature");
            if (k == null) {
                Puts ("Couln't find the EntityFluidEffectKey for Internal Temperature, cancelling...");
                return;
            }
            foreach (var l in RuntimeHurtDB.Instance.GetAll<ItemGeneratorStaticAsset> ()) {
                var trans = l.Components.FirstOrDefault (e => e is ItemComponentTransitionConfig);
                if (trans != null) {
                    var trans2 = (ItemComponentTransitionConfig) trans;
                    foreach (var t in trans2.Transitions) {
                        if (t.SourceEffectType == k && t.MinValue >= 400) {
                            t.RequiredDuration = 0;
                            t.TransitionStack = true;
                        }
                    }
                }
            }
#else

            GlobalItemManager GIM = Singleton<GlobalItemManager>.Instance;
            GIM.GetItem ((int) EItemCode.IronOre).GetType ().BaseType.GetProperty ("ResourceTransitions").SetValue (GIM.GetItem ((int) EItemCode.IronOre) as IItem, GenerateTransition ((int) EItemCode.ShapedIron), null);
            GIM.GetItem ((int) EItemCode.Metal2Ore).GetType ().BaseType.GetProperty ("ResourceTransitions").SetValue (GIM.GetItem ((int) EItemCode.Metal2Ore) as IItem, GenerateTransition ((int) EItemCode.ShapedMetal2), null);
            GIM.GetItem ((int) EItemCode.Metal3Ore).GetType ().BaseType.GetProperty ("ResourceTransitions").SetValue (GIM.GetItem ((int) EItemCode.Metal3Ore) as IItem, GenerateTransition ((int) EItemCode.ShapedMetal3), null);
            GIM.GetItem ((int) EItemCode.Metal4Ore).GetType ().BaseType.GetProperty ("ResourceTransitions").SetValue (GIM.GetItem ((int) EItemCode.Metal4Ore) as IItem, GenerateTransition ((int) EItemCode.ShapedMetal4), null);
#endif
        }
#if !HURTWORLD
        public List<EntityStatResourceTransition> GenerateTransition (int result) {
            EntityStatResourceTransition tr = new EntityStatResourceTransition {
                SourceEffectType = EEntityFluidEffectType.InternalTemperature,
                MinValue = 500f,
                MaxValue = 15000f,
                RequiredDuration = 1f,
                ResultItemId = result,
                Description = "Can be smelted at 500 degrees", //Server side only
                TransitionStack = true //This is the magic bit that makes that plugin work
            };
            return new List<EntityStatResourceTransition> { tr };
        }
#endif
    }
}